#define  STRICT
  #include <windows.h>
  #include <stdio.h>
  #include <dos.h>

#include "pp_Dll.h"

  /*
  This routine shows how to access an address in DOS memory using peek and poke functions.
  Only PEEK is shown; POKE would work the same way.
  As written, file creates an DLL file to read memory. The EXTERNAL KERNEL reference below
  tells the compiler that WORD is a reference to the exported value _????H from kernel.
  */

  extern WORD _near _0000H;    	// declare KERNEL exported selector to 0000
				// memory area; points to start of linear memory, including
                                // DOS  interrupt vector table

  extern WORD _near _0040H;    	// declare KERNEL exported selector to 0040
  				// memory area; BIOS/DOS areas

  extern WORD _near _A000H;    	// declare KERNEL exported selector to A000
  				// memory area; used by drivers and ROM

  extern WORD _near _B000H;    	// declare KERNEL exported selector to B000
  				// memory area; used by drivers and ROM

  extern WORD _near _B800H;    	// declare KERNEL exported selector to B800
  				// memory area; used by drivers and ROM

  extern WORD _near _C000H;    	// declare KERNEL exported selector to C000
  				// memory area; used by drivers and ROM

  extern WORD _near _D000H;    	// declare KERNEL exported selector to D000
  				// memory area; used by drivers and ROM

  extern WORD _near _E000H;    	// declare KERNEL exported selector to E000
  				// memory area; used by drivers and ROM

  extern WORD _near _F000H;    	// declare KERNEL exported selector to F000
  				// memory area; used by drivers and ROM



int FAR pascal _export Peek1stMeg(int id_code,int x )

{

    // set constants for clarity. These index values must be the same as
    // in the VB calling program.
    const area_0000=0, area_0040=1, area_A000=2, area_B000=3;
    const area_B800=4, area_C000=5, area_D000=6, area_E000=7;
    const area_F000=8;

    unsigned char far *fp;     // Declare a character pointer type "*fp" that will
    				// be used to contain the address to be peeked.

    /* Load fp with the pointer. MK_FP means MakeFarPointer out of the address pointed
    to by the selector (0x????H) and the offset, shown here as a "x". Routine uses the
    id_code to case select the correct EXTERN value.
    */

    switch(id_code) {
    case area_0000:
    fp = (unsigned char far *)(MK_FP((WORD)(&_0000H), x));
    break;
    case area_0040:
    fp = (unsigned char far *)(MK_FP((WORD)(&_0040H), x));
    break;
    case area_A000:
    fp = (unsigned char far *)(MK_FP((WORD)(&_A000H), x));
    break;
    case area_B000:
    fp = (unsigned char far *)(MK_FP((WORD)(&_B000H), x));
    break;
    case area_B800:
    fp = (unsigned char far *)(MK_FP((WORD)(&_B800H), x));
    break;
    case area_C000:
    fp = (unsigned char far *)(MK_FP((WORD)(&_C000H), x));
    break;
    case area_D000:
    fp = (unsigned char far *)(MK_FP((WORD)(&_D000H), x));
    break;
    case area_E000:
    fp = (unsigned char far *)(MK_FP((WORD)(&_E000H), x));
    break;
    case area_F000:
    fp = (unsigned char far *)(MK_FP((WORD)(&_F000H), x));
    }



   return (int) *fp;   /* return, as integer, byte pointed to by fp */
}

#pragma argsused
int FAR PASCAL LibMain( HINSTANCE hInstance,
			WORD wDataSegment,
			WORD wHeapSize,
			LPSTR lpszCmdLine )
{
if ( wHeapSize != 0 )
    UnlockData( 0 );
return 1;
}





#pragma argsused
int FAR PASCAL WEP ( int bSystemExit )
{
return 1;
}
