'===================================================
' ResCheck - Resource Checker
' Created by Dan Houck (Compuserve 71441,3227)
'
' Description: ResCheck monitors the GDI & User heap
' at 2 second intervals. If either falls below the
' minimums specified in RESCHECK.INI, a modal dialogue
' box appears, requiring user acknowledgement.
' When Icon-ized, a histogram of GDI & User is shown.
' When not an icon, more info about the environment
' is shown.
'
' This program is FreeWare.. Enjoy!
'
' References:
' MSJ Sept/Oct 1991 - Article by Paul Yao
'
'====================================================
'**** DTH Visual Basic General Declaration ****
DefInt A-Z

Global Const TRUE = -1
Global Const FALSE = 0

'**** From WINAPI.TXT ****
Declare Function LoadLibrary Lib "Kernel" (ByVal lpLibFileName As String) As Integer
Declare Sub FreeLibrary Lib "Kernel" (ByVal hLibModule As Integer)

Declare Function GlobalSize Lib "Kernel" (ByVal hMem As Integer) As Long
Declare Function GetFreeSpace Lib "Kernel" (ByVal wFlags) As Long

Declare Function GetWinFlags Lib "Kernel" () As Long

Global Const WF_PMODE = &H1
Global Const WF_CPU286 = &H2
Global Const WF_CPU386 = &H4
Global Const WF_CPU486 = &H8
Global Const WF_STANDARD = &H10
Global Const WF_WIN286 = &H10
Global Const WF_ENHANCED = &H20
Global Const WF_WIN386 = &H20
Global Const WF_CPU086 = &H40
Global Const WF_CPU186 = &H80
Global Const WF_LARGEFRAME = &H100
Global Const WF_SMALLFRAME = &H200
Global Const WF_80x87 = &H400

'*** ResCheck Specific ****
Global hLibGDI As Integer
Global hLibUser As Integer
Global GDInotified As Integer
Global USERnotified As Integer



